/* Droids-corp, Eirbot, Microb Technology 2005 - Zer0
 * Inspired by the ARC4 interface by Christophe Devine
 * The original licence is below
 * Interface for RC4
 */

/** \file rc4.c
 *  \brief Interface for the RC4 module.
 *
 *  \todo Test the module.
 *
 *  \test No tests for the moment.
 *
 * This module provides RC4 cryptographic functions.
 */

/*
 *  An implementation of the ARC4 algorithm
 *
 *  Copyright (C) 2001-2003  Christophe Devine
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _RC4_H
#define _RC4_H

#include <aversive.h>

struct rc4_state
{
  uint8_t x, y;
  uint8_t m[256];
};

void rc4_init( uint8_t *key,  uint8_t length );
uint8_t rc4_crypt_char(uint8_t data);

#endif /* rc4.h */
